;;nasm -fwin32 gtkwin.asm
;;golink /entry main "libgtk-win32-2.0-0.dll" "libgobject-2.0-0.dll" gtkwin.obj

%include "hll.inc"
%include "gtk.inc"

extern gtk_init, gtk_window_new, gtk_button_new_with_label
extern gtk_entry_new, gtk_hbox_new, gtk_window_set_title
extern g_signal_connect_data, gtk_box_pack_start, gtk_container_add
extern gtk_widget_show_all, gtk_main, gtk_exit
extern gtk_entry_get_text, gtk_message_dialog_new, gtk_dialog_run
extern gtk_widget_destroy

BITS 32
segment .bss

	window resd 1
	button resd 1
	hbox resd 1
	entry resd 1
	msgboxdiag resd 1
segment .code

proc main

	ccall gtk_init,NULL,NULL
	
	ccall gtk_window_new, GtkWindowType.GTK_WINDOW_TOPLEVEL
	mov [window],eax

	ccall gtk_button_new_with_label, "Echo"
	mov [button],eax

	ccall gtk_entry_new
	mov [entry],eax

	ccall gtk_hbox_new, FALSE, 2
	mov [hbox],eax

	ccall gtk_window_set_title, [window],"GTK application"
	
	ccall g_signal_connect_data,[window], "delete_event", kill_window, 0, 0, 0

	ccall g_signal_connect_data, [button], "clicked", button_press , 0, 0, 0

	ccall gtk_box_pack_start, [hbox],[entry],1,1,2

	ccall gtk_box_pack_start, [hbox],[button],0,0,2

	ccall gtk_container_add,[window],[hbox]

	ccall gtk_widget_show_all,[window]
	
	ccall gtk_main
	
	ccall gtk_exit,0
endproc

proc kill_window, widget,event, data
	uses "C"

	ccall gtk_main_quit
	return 0
endproc

proc button_press,widget,data
	uses "C"
	
	ccall gtk_entry_get_text,[entry]

	ccall gtk_message_dialog_new, [window], GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, eax
	mov [msgboxdiag],eax

	ccall gtk_window_set_title, [msgboxdiag], "Info"

	ccall gtk_dialog_run, [msgboxdiag]

	ccall gtk_widget_destroy, [msgboxdiag]

endproc
